device=0
pretrain_path=None
preprocess=None
hidden_channels=256
mlp_layer=1
K=5
data_root_dir=../../dataset

echo "gpu: $device"
python -u ./sagn.py \
    --dataset ogbn-products \
    --gpu $device \
    --aggr-gpu -1 \
    --model sagn \
    --seed 12345 \
    --num-runs 3 \
    --threshold 0.9 \
    --epoch-setting 500 200 200 \
    --lr 0.001 \
    --batch-size 50000 \
    --num-hidden $hidden_channels \
    --mlp-layer $mlp_layer \
    --dropout 0.5 \
    --attn-drop 0.4 \
    --input-drop 0.2 \
    --K ${K} \
    --label-K 9 \
    --use-labels \
    --weight-decay 0 \
    --warmup-stage -1 \
    --data_root_dir $data_root_dir \
    --pretrain_path $pretrain_path \
    --preprocess $preprocess \

    | tee -a ./LOGS/${hidden_channels}.${mlp_layer}.${K}.${pretrain_path}.${preprocess}.uselabels.log &
        

